--- a/Src/Zle/zle_main.c
+++ b/Src/Zle/zle_main.c
@@ -1353,7 +1353,7 @@ execzlefunc(Thingy func, char **args, int set_bindk)
 	    opts[XTRACE] = oxt;
 	    sfcontext = osc;
 	    endparamscope();
-	    lastcmd = 0;
+	    lastcmd = w->flags & ZLE_YANK;
 	    r = 1;
 	    redup(osi, 0);
 	}
@@ -1918,7 +1918,7 @@ zle_main_entry(int cmd, va_list ap)
 static struct builtin bintab[] = {
     BUILTIN("bindkey", 0, bin_bindkey, 0, -1, 0, "evaM:ldDANmrsLRp", NULL),
     BUILTIN("vared",   0, bin_vared,   1,  1, 0, "aAcehM:m:p:r:t:", NULL),
-    BUILTIN("zle",     0, bin_zle,     0, -1, 0, "aAcCDFgGIKlLmMNRU", NULL),
+    BUILTIN("zle",     0, bin_zle,     0, -1, 0, "aAcCDFgGIKlLmMNRUy", NULL),
 };
 
 /* The order of the entries in this table has to match the *HOOK
index f712e17..d671251 100644
--- a/Src/Zle/zle_thingy.c
+++ b/Src/Zle/zle_thingy.c
@@ -564,11 +564,11 @@ bin_zle_link(char *name, char **args, UNUSED(Options ops), UNUSED(char func))
 
 /**/
 static int
-bin_zle_new(char *name, char **args, UNUSED(Options ops), UNUSED(char func))
+bin_zle_new(char *name, char **args, Options ops, UNUSED(char func))
 {
     Widget w = zalloc(sizeof(*w));
 
-    w->flags = 0;
+    w->flags = OPT_ISSET(ops,'y') ? ZLE_YANK : 0;
     w->first = NULL;
     w->u.fnnam = ztrdup(args[1] ? args[1] : args[0]);
     if(!bindwidget(w, rthingy(args[0])))
